# ModifyInstanceBandwidth

## 1. API Description

The API is used to modify the bandwidth of an instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Bandwidth cap differs with different instance models. You can call</mark> <mark style="color:blue;">`DescribeInstanceTypes`</mark> <mark style="color:blue;">to obtain.</mark>
* <mark style="color:blue;">You can only perform this operation on instances whose status is</mark> <mark style="color:blue;">`RUNNING`</mark><mark style="color:blue;">.</mark>
* <mark style="color:blue;">If your current and target bandwidth are both in the free bandwidth scope, the change takes immediate effect.</mark>
* <mark style="color:blue;">If the</mark> [<mark style="color:purple;">`internetChargeType`</mark>](https://docs.console.zenlayer.com/api-reference/compute/datastructure#internetchargetype) <mark style="color:blue;">of your instance is</mark> <mark style="color:blue;">`ByBandwidth`</mark>
  * <mark style="color:blue;">For a</mark> <mark style="color:blue;">`PREPAID`</mark> <mark style="color:blue;">instance:</mark>
    * <mark style="color:blue;">Upgrade (target > current) operation will deduct the amount required for this instance purchase. If the balance is insufficient, the request will fail and take effect immediately.</mark>
    * <mark style="color:blue;">Downgrade (target < current) operation will generate an order for the next billing cycle and will take effect by then.</mark>
  * <mark style="color:blue;">For a</mark> <mark style="color:blue;">`POSTPAID`</mark> <mark style="color:blue;">instance, the change takes immediate effect.</mark>
* <mark style="color:blue;">Use</mark> <mark style="color:blue;">`InquiryPriceInstanceBandwidth`</mark> <mark style="color:blue;">to query price of bandwidth.</mark>
* <mark style="color:blue;">Use</mark> <mark style="color:blue;">`DescribeInstanceInternetStatus`</mark> <mark style="color:blue;">to query bandwidth status of an instance.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name   | Required | Type    | Description                                                                                                                                                                            |
| ---------------- | -------- | ------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceId       | Yes      | String  | <p>Instance ID.</p><p>To obtain the instance ID, you can call <a href="describeinstances"><code>DescribeInstances</code></a> and look for <code>instanceId</code> in the response.</p> |
| bandwidthOutMbps | Yes      | Integer | <p>Bandwidth.</p><p>Value range: from 1 to maximum supported for the instance model.</p>                                                                                               |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                              |
| -------------- | ------ | -------------------------------------------------------------------------------------------------------- |
| requestId      | String | The unique request ID, which is returned for each request. RequestId is required for locating a problem. |
| orderNumber    | String | Number of order.                                                                                         |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Upgrade the bandwidth of an instance**

```javascript
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyInstanceBandwidth
<Common Request Params>

Request：
{
  "instanceId": "instanceId",
  "bandwidthOutMbps": 100
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {  
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "orderNumber": "xxxx"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk) to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).​

| HTTP Status Code | Error Code                                         | Description                                                     |
| ---------------- | -------------------------------------------------- | --------------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                      | Instance does not exist.                                        |
| 403              | OPERATION\_DENIED\_INSTANCE\_NOT\_RUNNING          | Only operations on instances in `RUNNING` status are supported. |
| 400              | INVALID\_PARAMETER\_BANDWIDTH\_EXCEED              | Bandwidth exceeds upper limit.                                  |
| 403              | OPERATION\_FAILED\_INSTANCE\_BANDWIDTH\_PROCESSING | Bandwidth is being modified.                                    |
